// Fill out your copyright notice in the Description page of Project Settings.


#include "ViveOpenXRAndroidControllerBP.h"
#include "IMotionController.h"

bool UViveOpenXRAndroidControllerBP::IsAimControllerTracked(bool isLeft)
{
	FName MotionControllerName("OpenXR");
	TArray<IMotionController*> MotionControllers = IModularFeatures::Get().GetModularFeatureImplementations<IMotionController>(IMotionController::GetModularFeatureName());
	IMotionController* MotionController = nullptr;
	for (auto Itr : MotionControllers)
	{
		if (Itr->GetMotionControllerDeviceTypeName() == MotionControllerName)
		{
			MotionController = Itr;
			break;
		}
	}

	if (MotionController)
	{
		FName AimSource = isLeft ? FName("LeftAim") : FName("RightAim");
		auto trackingStatus = MotionController->GetControllerTrackingStatus(0, AimSource);
		return (trackingStatus == ETrackingStatus::Tracked);
	}

	return false;
}

bool UViveOpenXRAndroidControllerBP::IsGripControllerTracked(bool isLeft)
{
	FName MotionControllerName("OpenXR");
	TArray<IMotionController*> MotionControllers = IModularFeatures::Get().GetModularFeatureImplementations<IMotionController>(IMotionController::GetModularFeatureName());
	IMotionController* MotionController = nullptr;
	for (auto Itr : MotionControllers)
	{
		if (Itr->GetMotionControllerDeviceTypeName() == MotionControllerName)
		{
			MotionController = Itr;
			break;
		}
	}

	if (MotionController)
	{
		FName GripSource = isLeft ? FName("LeftGrip") : FName("RightGrip");
		auto trackingStatus = MotionController->GetControllerTrackingStatus(0, GripSource);
		return (trackingStatus == ETrackingStatus::Tracked);
	}

	return false;
}
