// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "ViveOpenXRAndroidControllerBP.generated.h"

UCLASS()
class UViveOpenXRAndroidControllerBP : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()
	
public:
	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|Toolkit|Controller",
		meta = (ToolTip = "Checks if the controller with Motion Source Aim is tracked."))
	static bool IsAimControllerTracked(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|Toolkit|Controller",
		meta = (ToolTip = "Checks if the controller with Motion Source Grip is tracked."))
	static bool IsGripControllerTracked(bool isLeft);
};
