// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "ViveOpenXRAndroidSettings.generated.h"

/**
 * ViveOpenXRAndroid developer settings
 */
UCLASS(config=Engine, defaultconfig)
class VIVEOPENXRANDROIDEDITOR_API UViveOpenXRAndroidSettings : public UObject
{
	GENERATED_UCLASS_BODY()

public:
	UPROPERTY(EditAnywhere, config, Category = "Hand", meta = (
		ConsoleVariable = "wave.HandInteraction.enable", DisplayName = "Enable Hand Interaction",
		ToolTip = "To enable Hand Interaction feature."))
	bool bHandInteractionEnable;

	UPROPERTY(EditAnywhere, config, Category = "Tracker", meta = (
		ConsoleVariable = "wave.WristTracker.enable", DisplayName = "Enable Wrist Tracker",
		ToolTip = "To modify the AndroidManifest.xml for using the Wrist Tracker feature."))
	bool bWristTrackerEnable;

	UPROPERTY(EditAnywhere, config, Category = "Controller", meta = (
		ConsoleVariable = "wave.ControllerFocus3.enable", DisplayName = "Enable Focus3 Controller",
		ToolTip = "To support Focus3 controller."))
	bool bControllerFocus3Enable;

	UPROPERTY(EditAnywhere, config, Category = "Facial Tracking", meta = (
		ConsoleVariable = "wave.FacialTracking.enable", DisplayName = "Enable Facial Tracking",
		ToolTip = "To support the Facial Tracking feature."))
	bool bFacialTrackingEnable;

public:
	//~ Begin UObject Interface
	virtual void PostInitProperties() override;

#if WITH_EDITOR
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
	//~ End UObject Interface
};
