// Copyright (c) 2022 HTC Corporation. All Rights Reserved.

#include "ViveOpenXRAndroidFacialTrackingFunctionLibrary.h"
#include "ViveOpenXRAndroidFacialTracking.h"

void UViveOpenXRAndroidFacialTrackingFunctionLibrary::GetIsFacialTrackingEnabled(bool& result)
{
	if (!GetViveOpenXRAndroidFacialTrackingModule().FTSource.IsValid()) return;
	result = GetViveOpenXRAndroidFacialTrackingModule().FTSource->m_bEnableFacialTracking;
}

bool UViveOpenXRAndroidFacialTrackingFunctionLibrary::CreateFacialTracker(EXrFacialTrackingType trackingType)
{
	XrFacialTrackingTypeHTC trackType = static_cast<XrFacialTrackingTypeHTC>(trackingType);
	if (!GetViveOpenXRAndroidFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRAndroidFacialTrackingModule().FTSource->CreateFacialTracker(trackType);
}

bool UViveOpenXRAndroidFacialTrackingFunctionLibrary::DestroyFacialTracker(EXrFacialTrackingType trackingType)
{
	XrFacialTrackingTypeHTC trackType = static_cast<XrFacialTrackingTypeHTC>(trackingType);
	if (!GetViveOpenXRAndroidFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRAndroidFacialTrackingModule().FTSource->DestroyFacialTracker(trackType);
}

bool UViveOpenXRAndroidFacialTrackingFunctionLibrary::GetEyeFacialExpressions(bool& isActive, TMap<EEyeShape, float>& blendshapes)
{
	if (!GetViveOpenXRAndroidFacialTrackingModule().FTSource.IsValid()) return false;
	bool isSuccess = GetViveOpenXRAndroidFacialTrackingModule().FTSource->GetEyeExpressions(isActive);
	blendshapes = GetViveOpenXRAndroidFacialTrackingModule().FTSource->eyeShapes;
	return isSuccess;
}

bool UViveOpenXRAndroidFacialTrackingFunctionLibrary::GetLipFacialExpressions(bool& isActive, TMap<ELipShape, float>& blendshapes)
{
	if (!GetViveOpenXRAndroidFacialTrackingModule().FTSource.IsValid()) return false;
	bool isSuccess = GetViveOpenXRAndroidFacialTrackingModule().FTSource->GetLipExpressions(isActive);
	blendshapes = GetViveOpenXRAndroidFacialTrackingModule().FTSource->lipShapes;
	return isSuccess;
}