// Copyright HTC Corporation. All Rights Reserved.

#include "HAL/IConsoleManager.h"

// https://docs.unrealengine.com/en-us/Programming/Development/Tools/ConsoleManager

namespace Wave {
namespace ConsoleVariable {

/*
static TAutoConsoleVariable<int32> CVarTemplate(
	TEXT("wave."),
	1,  // Default value
	TEXT("1. Enable .\n")
	TEXT("0. Disable it.\n")
	TEXT("note, or orther description.\n"),
	ECVF_RenderThreadSafe);
*/

/****************************************************
 *
 * Console Variable: Interaction
 *
 ****************************************************/

static TAutoConsoleVariable<bool> CVarHandInteractionEnable(
	TEXT("wave.HandInteraction.enable"),
	false, /*default value*/
	TEXT("false. Disable the Hand Interaction feature.\n")
	TEXT("true. Enable the Hand Interaction feature.\n"),
	ECVF_SetByProjectSetting);

static TAutoConsoleVariable<bool> CVarWristTrackerEnable(
	TEXT("wave.WristTracker.enable"),
	false, /*default value*/
	TEXT("false. Disable the Wrist Tracker feature.\n")
	TEXT("true. Enable the Wrist Tracker feature.\n"),
	ECVF_SetByProjectSetting);

static TAutoConsoleVariable<bool> CVarControllerFocus3Enable(
	TEXT("wave.ControllerFocus3.enable"),
	true, /*default value*/
	TEXT("false. Disable Focus3 controller.\n")
	TEXT("true. Enable Focus3 controller.\n"),
	ECVF_SetByProjectSetting);

static TAutoConsoleVariable<bool> CVarFacialTrackingEnable(
	TEXT("wave.FacialTracking.enable"),
	false, /*default value*/
	TEXT("false. Disable the Facial Tracking feature.\n")
	TEXT("true. Enable the Facial Tracking feature.\n"),
	ECVF_SetByProjectSetting);

}  // namespace ConsoleVariable
}  // namespace Wave
