// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "UObject/Interface.h"
#include "WaveHandInteractInterface.generated.h"

// This class does not need to be modified.
UINTERFACE(MinimalAPI)
class UWaveHandInteractInterface : public UInterface
{
	GENERATED_BODY()
};

class IWaveHandInteractInterface
{
	GENERATED_BODY()

	// Add interface functions to this class. This is the class that will be inherited to implement this interface.
public:
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnHandEnter(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category="Wave|OpenXR|Interaction")
	void OnHandHover(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnHandExit(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnHandClick(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnHandDown(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnHandUp(AActor* caller);

/**
 * Usage:
 * For the "inherited" UClass object (ex: AActor):
 *
 * IWaveHandInteractInterface* interface = Cast<IWaveHandInteractInterface>(<ActorInstance>);
 * if (interface)
 * {
 *     interface->Execute_OnHandHover(<ActorInstance>, GetOwner());
 * }
 *
 * For the "implemented" Blueprint object (ex: Actor):
 *
 * if (<ActorInstance>->GetClass()->ImplementsInterface(UWaveHandInteractInterface::StaticClass()))
 * {
 *     IWaveHandInteractInterface::Execute_OnHandHover(<ActorInstance>, GetOwner());
 * }
 **/
};
