# 12.70. XR_HTC_vive_wrist_tracker_interaction
## Name String
    XR_HTC_vive_wrist_tracker_interaction
## Revision
    1
## VIVE Wrist Tracker input
### Interaction profile path:
- /interaction_profiles/htc/vive_wrist_tracker

### Valid for user paths:
- /user/wrist_htc/left
- /user/wrist_htc/right

### Supported input source
- On /user/wrist_htc/left only:
  - K/input/menu/click
  - K/input/x/click
- On /user/wrist_htc/right only:
  - K/input/system/click (may not be available for application use) 
  - K/input/a/click
- K/input/entity_htc/pose

The entity_htc pose allows the applications to recognize the origin of a tracked input device, especially for the wearable devices which are not held in the users hand. The entity_htc pose is defined as follows:

- The entity position: The center position of the tracked device.
- The entity orientation: Oriented with +Y up, +X to the right, and -Z forward.

## Wave Blueprint Function Library
- FVector UViveOpenXRAndroidWristTrackerBP::GetTrackerPosition(bool isLeft)
- FQuat UViveOpenXRAndroidWristTrackerBP::GetTrackerRotation(bool isLeft)
- bool UViveOpenXRAndroidWristTrackerBP::GetTrackerTracked(bool isLeft)
- bool UViveOpenXRAndroidWristTrackerBP::GetTrackerKeyDown(bool isLeft, TrackerButton key)

## Wave Tracker Input
- Tracker ( L ) Menu: Left key "Menu" press state.
- Tracker ( L ) X Press: Left key "X" press state.
- Tracker ( R ) System: Right key "System" press state. (may not be available for application use) 
- Tracker ( R ) A Press: Right key "A" press state.
