// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"

#include "ViveOpenXRAndroidWristTrackerEnums.h"

#include "ViveOpenXRAndroidWristTrackerBP.generated.h"

UCLASS()
class UViveOpenXRAndroidWristTrackerBP : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

public:
	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Retrieves the left or right tracker rotation."))
	static FQuat GetTrackerRotation(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Retrieves the left or right tracker position."))
	static FVector GetTrackerPosition(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Checks if the tracker is active."))
	static bool GetTrackerActive(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Checks if the tracker is valid."))
	static bool GetTrackerValid(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Checks if the tracker is tracked."))
	static bool GetTrackerTracked(bool isLeft);

	UFUNCTION(
		BlueprintCallable,
		Category = "ViveOpenXRAndroid|OpenXR|WristTracker",
		meta = (ToolTip = "Checks if a tracker button is pressed."))
	static bool GetTrackerKeyDown(bool isLeft, TrackerButton key);
};
